package cn.ey.biz.module.system.api.dept;

import cn.ey.biz.common.pojo.R;
import cn.ey.biz.module.system.api.dept.dto.DeptRespDTO;
import cn.ey.biz.module.system.convert.dept.DeptConvert;
import cn.ey.biz.module.system.dal.dataobject.dept.DeptDO;
import cn.ey.biz.module.system.service.dept.DeptService;
import org.apache.dubbo.config.annotation.DubboService;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import java.util.Collection;
import java.util.List;

import static cn.ey.biz.common.pojo.R.success;
import static cn.ey.biz.module.system.enums.ApiConstants.VERSION;

@RestController // 提供 RESTful API 接口，给 Feign 调用
@DubboService(version = VERSION) // 提供 Dubbo RPC 接口，给 Dubbo Consumer 调用
@Validated
public class DeptApiImpl implements DeptApi {

    @Resource
    private DeptService deptService;

    @Override
    public R<DeptRespDTO> getDept(Long id) {
        DeptDO dept = deptService.getDept(id);
        return success(DeptConvert.INSTANCE.convert03(dept));
    }

    @Override
    public R<List<DeptRespDTO>> getDepts(Collection<Long> ids) {
        List<DeptDO> depts = deptService.getDepts(ids);
        return success(DeptConvert.INSTANCE.convertList03(depts));
    }

    @Override
    public R<Boolean> validDepts(Collection<Long> ids) {
        deptService.validDepts(ids);
        return success(true);
    }

}
